Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
Well, that happens sometime (bad merge)
[simgrid.git] / src / smpi / smpiff.in
index d393bd0..38276ad 100644 (file)
@@ -1,64 +1,64 @@
 #! /bin/sh
 
-prefix="@exec_prefix@"
-smpicc="$prefix/bin/smpicc"
-smpif2c="$prefix/bin/smpif2c"
+# Copyright (c) 2012-2014. The SimGrid Team.
+# All rights reserved.
+
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the license (GNU LGPL) which comes with this package.
+
+SIMGRID_VERSION="@SIMGRID_VERSION_STRING@"
+
+F77=@GFORTRAN_EXE@
+
+INCLUDEARGS="@includeflag@"
+CMAKE_LINKARGS="-L@libdir@"
 
 @SMPITOOLS_SH@
 
-list_set ARGS "-DMAIN__=user_main" "-Diargc_=smpi_process_argc" "-Dgetarg_=smpi_process_getarg"
-list_set LINKARGS "-L@F2C_LIBRARY_PATH@" "-lf2c" "-lm"
-list_set SRCFILES
+list_set FFLAGS "-ff2c" "-fno-second-underscore"
+list_set LINKARGS "-lsimgrid" "-lm" "-lgfortran"
+list_set TMPFILES
+main_name=main
+
+cleanup () {
+    eval $(list_get TMPFILES)
+   # rm -f "$@"
+}
+trap 'cleanup' EXIT
 
+list_set CMDLINE "${F77}"
+list_add_not_empty CMDLINE "${FFLAGS}"
 while [ $# -gt 0 ]; do
     ARG="$1"
     shift
     case "${ARG}" in
-        *.f)
-            SRCFILE="$(readlink -f ${ARG} 2>/dev/null)"
-            if [ -z "$SRCFILE" ] ; then
-                SRCFILE="$ARG"
-            fi
-            list_add SRCFILES "${SRCFILE}"
+        -c)
+            CMAKE_LINKARGS=""
+            LINKARGS=""
+            list_add CMDLINE "-c"
             ;;
+        *.f|*.F)
+            TMPFILE=$(mymktemp "${ARG}" ".f")
+            list_add TMPFILES "${TMPFILE}"
+      #replace "program main_name by subroutine user\_main (and the end clause as well)"
+            sed 's/[[:space:]]\{6\}[[:space:]]*\(end \)\{0,1\}program[[:space:]]*\([a-zA-Z0-9\-\_]*\)/      \1subroutine user_main /gI;s/[[:space:]]*use[[:space:]]*mpi/\include \"mpif\.h\" /gI' "${ARG}" > "${TMPFILE}"
+            SRCFILE="${TMPFILE}"
+            list_add CMDLINE "${SRCFILE}"
+            ;;
+        '-version' | '--version' | '-v')
+            # -e is not recognised by MS-DOS...
+            echo -e $SIMGRID_VERSION
+            exit 0
+            ;;           
         *)
-            if [ "${ARG}" = "-c" ]; then
-                LINKARGS=""
-            fi
-            list_add ARGS "${ARG}"
+            list_add CMDLINE "${ARG}"
             ;;
     esac
 done
-list_add_not_empty ARGS "${LINKARGS}"
-
-build () {
-    local SRCFILE
-    SRCFILE="$1"
-    TMPFILE=$(mymktemp "${SRCFILE}" ".f")
-    CFILE="${TMPFILE%.f}.c"
-
-    eval $(list_get ARGS)
 
-    cp "${SRCFILE}" "${TMPFILE}" \
-        && "$smpif2c" "${TMPFILE}" \
-        && "$smpicc" "$@" "${CFILE}" \
-        && rm -f "${CFILE}" \
-        && rm -f "${TMPFILE}" \
-        || exit $?
-
-    # When the file is compiled with "-c" and no output file is specified with
-    # "-o", rename the output.  FIXME: do it properly.
-    if [ -f "${CFILE%.c}.o" ]; then
-        mv "${CFILE%.c}.o" "${SRCFILE%.f}.o"
-    fi
-}
+list_add_not_empty CMDLINE ${INCLUDEARGS}
+list_add_not_empty CMDLINE ${CMAKE_LINKARGS}
+list_add_not_empty CMDLINE "${LINKARGS}"
 
-if [ -n "${SRCFILES}" ]; then
-    eval $(list_get SRCFILES)
-    for SRCFILE in "$@"; do
-        build "$SRCFILE"
-    done
-else
-    eval $(list_get ARGS)
-    "$smpicc" "$@"
-fi
+eval $(list_get CMDLINE)
+"$@"